'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
require('prop-types');

var Resources = {};
Resources.keywordIDs = {
        'ok lamp': new Uint8Array([0xac, 0x24, 0x75, 0x21, 0x14, 0x3d, 0x2a, 0xe7, 0x0a, 0x85, 0x75, 0x4c, 0x48, 0x31, 0x5b, 0x44, 0x4b, 0xb6, 0xe8, 0xc3, 0x77, 0x30, 0xd5, 0xac, 0xca, 0x54, 0x06, 0x29, 0xbd, 0x15, 0xca, 0x90, 0x55, 0x81, 0xae, 0x21, 0x6a, 0x04, 0x1e, 0x5a, 0x9d, 0x64, 0x83, 0x0c, 0x04, 0x03, 0x6b, 0xe8, 0x22, 0x2e, 0x19, 0xbf, 0x7e, 0x2b, 0x4d, 0x8c, 0x50, 0x27, 0xb6, 0x11, 0xf3, 0x17, 0xc3, 0xf9, 0xe3, 0x69, 0x19, 0x26, 0xbe, 0x0d, 0xad, 0x78, 0x74, 0x61, 0x4b, 0xb8, 0xde, 0x83, 0x1c, 0xb9, 0xa1, 0x06, 0x27, 0x77, 0x03, 0xb2, 0x24, 0x82]) };

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

/* global navigator */
// Polyfill: mediaDevices.
// Not work on Desktop Safari, IE.
// Not work on Mobile browsers.

var nav = {};
nav.mediaDevices = function () {
    if (navigator.mediaDevices) {
        return navigator.mediaDevices;
    }

    navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia || navigator.msGetUserMedia;
    if (navigator.getUserMedia) {
        return {
            getUserMedia: function getUserMedia(c) {
                return new Promise(function (y, n) {
                    navigator.getUserMedia.call(navigator, c, y, n);
                });
            }
        };
    }
}();
if (!nav.mediaDevices) {
    alert("mediaDevices() not supported.");
    throw new Error("mediaDevices() not supported.");
}

// Polyfill: AudioContext.
window.AudioContext = window.AudioContext || window.webkitAudioContext || window.mozAudioContext || window.msAudioContext;

var AudioMeter = function (_Component) {
    inherits(AudioMeter, _Component);

    function AudioMeter(props) {
        classCallCheck(this, AudioMeter);

        var _this = possibleConstructorReturn(this, (AudioMeter.__proto__ || Object.getPrototypeOf(AudioMeter)).call(this, props));

        _this.state = {
            volume: 0,
            debug: false
        };
        return _this;
    }

    createClass(AudioMeter, [{
        key: "componentDidMount",
        value: function componentDidMount() {

            // Processing.
            var process = function (event) {
                var buf = event.inputBuffer.getChannelData(0);
                var sum = 0;
                var x;

                for (var i = 0; i < buf.length; i++) {
                    x = buf[i];
                    sum += x * x;
                }

                var rms = Math.sqrt(sum / buf.length);
                this.setState({
                    volume: Math.max(rms, this.state.volume * this.averaging)
                });
                //console.log('Volume: ' + this.state.volume);
                if (this.state.volume > (this.props.volumeWarning > 0 ? this.props.volumeWarning : 0.25)) this.canvasCtx.fillStyle = this.props.style.tooLoudColor ? this.props.style.tooLoudColor : '#FF0000';else this.canvasCtx.fillStyle = this.props.style.color ? this.props.style.color : '#00FF48';
                this.canvasCtx.clearRect(0, 0, this.canvasCtx.canvas.width, this.canvasCtx.canvas.height);
                this.canvasCtx.fillRect(0, this.canvasCtx.canvas.height * (1 - this.state.volume * 2), this.canvasCtx.canvas.width, this.canvasCtx.canvas.height);
            }.bind(this);

            // Init processing.
            nav.mediaDevices.getUserMedia({
                audio: true
            }).then(function (stream) {
                var audioCtx = new AudioContext();
                var source = audioCtx.createMediaStreamSource(stream);
                var processor = audioCtx.createScriptProcessor(256);

                this.averaging = 0.95;
                this.canvasCtx = this.refs.canvas.getContext('2d');
                this.canvasCtx.fillStyle = this.props.style.color ? this.props.style.color : '#00FF48';

                processor.onaudioprocess = process;
                processor.connect(audioCtx.destination);
                source.connect(processor);
            }.bind(this)).catch(function (err) {
                console.log('Error occurred while initalizing audio input: ' + err.toString());
            });
        }
    }, {
        key: "render",
        value: function render() {

            var canvasStyle = this.props.style ? Object.assign({}, this.props.style) : {};
            canvasStyle.height = this.props.style.height > 0 ? this.props.style.height : 78;
            canvasStyle.width = this.props.style.width > 0 ? this.props.style.width : 30;
            return React__default.createElement("canvas", { style: canvasStyle, ref: "canvas", width: canvasStyle.width, height: canvasStyle.height });
        }
    }]);
    return AudioMeter;
}(React.Component);

/* global window */
var hark = require('hark');

var SnipsMicrophone = function (_Component) {
    inherits(SnipsMicrophone, _Component);

    function SnipsMicrophone(props) {
        classCallCheck(this, SnipsMicrophone);

        var _this = possibleConstructorReturn(this, (SnipsMicrophone.__proto__ || Object.getPrototypeOf(SnipsMicrophone)).call(this, props));

        _this.startRecording = function () {
            //   console.log('START');
            this.recording = true;
            this.audioBuffer = [];
            this.recordingLength = 0;

            this.setState({ speaking: true, recording: true, lastIntent: '', lastTts: '', lastTranscript: '', showMessage: false });
            // ask snips to start listening to our audio stream

            this.sendHotwordDetected.bind(this)(this.hotwordId, this.siteId);
        };

        _this.stopRecording = function () {
            // console.log('STOP');
            console.log(['STOP REC']);
            this.logAudio(this.sessionId, this.audioBuffer);
            this.recording = false;
            this.setState({ recording: false });
            this.sendEndSession.bind(this)(this.sessionId);
        };

        _this.sensitivities = new Float32Array([1]);

        _this.keywordIDs = Resources.keywordIDs;
        _this.state = { recording: false, messages: [], lastIntent: '', lastTts: '', lastTranscript: '', showMessage: false, activated: false, speaking: false, showConfig: false, connected: false, config: {}, logs: {} };
        _this.recording = false;
        _this.siteId = _this.props.sitedId ? _this.props.sitedId : 'browser'; //+parseInt(Math.random()*100000000,10);
        _this.clientId = _this.props.clientId ? _this.props.clientId : 'client' + parseInt(Math.random() * 100000000, 10);
        _this.hotwordId = _this.props.hotwordId ? _this.props.hotwordId : 'default';
        _this.sessionId = "";
        _this.context = null;
        _this.messageTimeout = null;
        _this.mqttClient = null;
        _this.speakingTimeout = null;
        _this.failCount = 0;
        _this.hotwordManager = null;
        _this.speechEvents = null;
        _this.audioBuffer = [];
        _this.debug = _this.props.debug ? true : false;
        // default mqtt server localhost
        _this.mqttServer = _this.props.mqttServer && _this.props.mqttServer.length > 0 ? _this.props.mqttServer : 'localhost';
        // default websockets port
        _this.mqttPort = _this.props.mqttPort && _this.props.mqttPort.length > 0 ? _this.props.mqttPort : '9001';
        _this.startRecording = _this.startRecording.bind(_this);
        _this.stopRecording = _this.stopRecording.bind(_this);
        _this.onConnect = _this.onConnect.bind(_this);
        _this.startRecorder = _this.startRecorder.bind(_this);
        _this.onConnectionLost = _this.onConnectionLost.bind(_this);
        _this.onMessageArrived = _this.onMessageArrived.bind(_this);
        _this.sendAudioBuffer = _this.sendAudioBuffer.bind(_this);
        _this.audioBufferToWav = _this.audioBufferToWav.bind(_this);
        _this.reSample = _this.reSample.bind(_this);
        _this.encodeWAV = _this.encodeWAV.bind(_this);
        _this.interleave = _this.interleave.bind(_this);
        _this.playSound = _this.playSound.bind(_this);
        _this.cssRule = _this.cssRule.bind(_this);
        _this.getPointerLength = _this.getPointerLength.bind(_this);
        _this.bubbleCSS = _this.bubbleCSS.bind(_this);
        _this.flashState = _this.flashState.bind(_this);
        _this.showConfig = _this.showConfig.bind(_this);
        _this.showConfigNow = _this.showConfigNow.bind(_this);
        _this.hideConfig = _this.hideConfig.bind(_this);
        _this.clearConfigTimer = _this.clearConfigTimer.bind(_this);
        _this.activate = _this.activate.bind(_this);
        _this.deactivate = _this.deactivate.bind(_this);
        _this.hotwordCallback = _this.hotwordCallback.bind(_this);
        _this.logAudio = _this.logAudio.bind(_this);
        _this.logTts = _this.logTts.bind(_this);
        _this.logAsr = _this.logAsr.bind(_this);
        _this.logIntent = _this.logIntent.bind(_this);
        _this.currentLogEntry = _this.currentLogEntry.bind(_this);
        _this.resetConfig = _this.resetConfig.bind(_this);
        return _this;
    }

    createClass(SnipsMicrophone, [{
        key: 'componentDidMount',


        /**
         * Lifecycle functions
         */

        /**
         * Activate on mount if user has previously enabled.
         */
        value: function componentDidMount() {
            this.initSpeechSynthesis.bind(this)();
            var configString = localStorage.getItem('snipsmicrophone_config');
            var config = null;
            try {
                config = JSON.parse(configString);
            } catch (e) {}
            console.log(['LOAD CONFIG', config, configString]);
            if (config) {
                // load config
                this.setState({ 'config': config });
            } else {
                // default config
                var newConfig = this.getDefaultConfig.bind(this)();

                this.setState({ 'config': newConfig });
                localStorage.setItem('snipsmicrophone_config', JSON.stringify(newConfig));
            }
            // if previously activated, restore microphone
            if (localStorage.getItem('snipsmicrophone_enabled') === 'true') {
                this.activate(false);
            }
        }
    }, {
        key: 'resetConfig',
        value: function resetConfig() {
            var newConfig = this.getDefaultConfig.bind(this)();
            this.setState({ 'config': newConfig });
            localStorage.setItem('snipsmicrophone_config', JSON.stringify(newConfig));
        }
    }, {
        key: 'getDefaultConfig',
        value: function getDefaultConfig() {
            //console.log(['GDC',this.state]);
            return {
                inputvolume: '70',
                outputvolume: '70',
                voicevolume: '70',
                ttsvoice: 'default', //this.state.voices && this.state.voices.length > 0 ? this.state.voices[0].name :
                voicerate: '50',
                voicepitch: '50',
                remotecontrol: 'local',
                hotword: 'browser:oklamp',
                silencedetection: 'yes',
                silencedetectionsensitivity: '5',
                enabletts: 'yes',
                enableaudio: 'yes',
                enablenotifications: 'yes'
            };
        }
    }, {
        key: 'deactivate',


        /**
         * Garbage collect mqtt and voice recorders.
         */
        value: function deactivate() {
            console.log(['deactivate', this.mqttClient]);
            localStorage.setItem('snipsmicrophone_enabled', 'false');
            if (this.mqttClient) {
                this.mqttClient.disconnect();
                delete this.mqttClient;
            }
            this.setState({ connected: false, recording: false });
        }
    }, {
        key: 'activate',


        /**
         * Connect to mqtt, start the recorder and optionally start listening
         * Triggered by microphone click or hotword
         */
        value: function activate() {
            var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

            var that = this;
            localStorage.setItem('snipsmicrophone_enabled', 'true');
            this.mqttConnect.bind(this)(start);
            if (start) {
                setTimeout(function () {
                    that.startRecording();
                }, 500);
            }
        }
    }, {
        key: 'mqttConnect',


        /**
         * Connect to mqtt server
        */
        value: function mqttConnect() {
            this.mqttClient = new Paho.MQTT.Client(this.mqttServer, Number(this.mqttPort), this.clientId);
            this.mqttClient.onConnectionLost = this.onConnectionLost;
            this.mqttClient.onMessageArrived = this.onMessageArrived;
            this.mqttClient.connect({ onSuccess: this.onConnect });
        }
    }, {
        key: 'onConnect',


        /**
         * Subscribe to to mqtt channels then start recorder
         */
        value: function onConnect() {
            this.setState({ 'connected': true });
            this.failCount = 0;
            this.mqttClient.subscribe("hermes/dialogueManager/#", {});
            this.mqttClient.subscribe("hermes/intent/#", {});
            this.mqttClient.subscribe("hermes/tts/#", {});
            this.mqttClient.subscribe("hermes/audioServer/" + this.siteId + "/#", {});
            this.mqttClient.subscribe("hermes/hotword/#", {});
            this.mqttClient.subscribe("hermes/asr/#", {});
            this.startRecorder();
        }

        /**
         * When the client loses its connection, reconnect after 5s
         */

    }, {
        key: 'onConnectionLost',
        value: function onConnectionLost(responseObject) {
            var that = this;
            this.setState({ 'connected': false, 'activated': false });
            if (responseObject.errorCode !== 0) {
                console.log("onConnectionLost:" + responseObject.errorMessage);
                var timeout = 1000;
                if (this.failCount > 5) {
                    timeout = 10000;
                }
                this.failCount++;
                setTimeout(function () {
                    that.mqttClient.connect({ onSuccess: that.onConnect });
                }, timeout);
            }
        }

        /**
         * Bind silence recognition events to set speaking state
         */

    }, {
        key: 'bindSpeakingEvents',
        value: function bindSpeakingEvents(e) {
            var that = this;
            var options = {};
            options.threshold = 10 * Math.log(this.state.config.silencesensitivity / 100);
            // bind speaking events care of hark
            if (this.state.config.silencedetection !== "no") {
                this.speechEvents = hark(e, options);
                this.speechEvents.on('speaking', function () {
                    if (this.speakingTimeout) clearTimeout(this.speakingTimeout);
                    that.setState({ speaking: true });
                });

                this.speechEvents.on('stopped_speaking', function () {
                    if (this.speakingTimeout) clearTimeout(this.speakingTimeout);
                    this.speakingTimeout = setTimeout(function () {
                        that.setState({ speaking: false });
                    }, 1000);
                });
            }
        }
    }, {
        key: 'startRecorder',


        /**
         * Access the microphone and start streaming mqtt packets
         */
        value: function startRecorder() {
            var that = this;
            if (!navigator.getUserMedia) navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia || navigator.msGetUserMedia;

            if (navigator.getUserMedia) {
                navigator.getUserMedia({ audio: true }, success, function (e) {
                    alert('Error capturing audio.');
                });
                //this.startVUMeter();
            } else alert('getUserMedia not supported in this browser.');

            function success(e) {
                that.setState({ 'activated': true });
                that.bindSpeakingEvents.bind(that)(e);
                // start media streaming mqtt
                var audioContext = window.AudioContext || window.webkitAudioContext;
                that.context = new audioContext();
                var audioInput = that.context.createMediaStreamSource(e);
                var bufferSize = 256;
                var recorder = that.context.createScriptProcessor(bufferSize, 1, 1);

                recorder.onaudioprocess = function (e) {
                    if (!that.recording || !that.state.speaking) return;
                    var left = e.inputBuffer.getChannelData(0);
                    that.sendAudioBuffer(e.inputBuffer, that.context.sampleRate);
                    console.log(['send audio', buffer, that.audioBuffer]);
                    that.audioBuffer.push(new Float32Array(e.inputBuffer.getChannelData(0)));
                    that.recordingLength += bufferSize;
                };

                audioInput.connect(recorder);
                recorder.connect(that.context.destination);
                that.sendHotwordToggleOn.bind(that)(that.siteId);
            }
        }
    }, {
        key: 'speakAloud',

        /**
         * Synthesise speech from text and send to to audio output
         */
        value: function speakAloud(text) {
            if (this.state.config.enablevoice !== "no") {
                var voice = this.state.config.ttsvoice ? this.state.config.ttsvoice : 'default';
                console.log(['SPEAK', voice, text, this.state.config.ttsvoice, this.state.config.voicevolume, this.state.config.voicerate, this.state.config.voicepitch]);

                if (voice === "default") {
                    // js generated fallback
                    speak(text, {
                        amplitude: !isNaN(parseFloat(this.state.config.voicevolume)) ? parseFloat(this.state.config.voicevolume) : 70,
                        pitch: !isNaN(parseFloat(this.state.config.voicepitch)) ? parseFloat(this.state.config.voicepitch) : 50,
                        speed: !isNaN(parseFloat(this.state.config.voicerate)) ? parseFloat(this.state.config.voicerate) * 2.2 : 175
                    });
                } else {
                    // Create a new instance of SpeechSynthesisUtterance.
                    var msg = new SpeechSynthesisUtterance();
                    msg.text = text;
                    msg.volume = !isNaN(parseFloat(this.state.config.voicevolume)) ? parseFloat(this.state.config.voicevolume) : 50;
                    msg.rate = !isNaN(parseFloat(this.state.config.voicerate)) ? parseFloat(this.state.config.voicerate) / 100 : 50 / 100;
                    msg.pitch = !isNaN(parseFloat(this.state.config.voicepitch)) ? parseFloat(this.state.config.voicepitch) : 50;
                    var voices = speechSynthesis.getVoices();

                    // Loop through each of the voices.
                    voices.forEach(function (voiceItem, i) {
                        if (voiceItem.name === voice) msg.voice = voiceItem;
                        window.speechSynthesis.speak(msg);
                    });
                }
            }
        }
    }, {
        key: 'initSpeechSynthesis',
        value: function initSpeechSynthesis() {
            var that = this;
            if ('speechSynthesis' in window) {

                // Fetch the list of voices and populate the voice options.
                var loadVoices = function loadVoices() {
                    // Fetch the available voices.
                    var voices = speechSynthesis.getVoices();

                    // Loop through each of the voices
                    var voiceOptions = [];
                    voices.forEach(function (voice, i) {
                        // Create a new option element.
                        console.log(voice);
                        voiceOptions.push({ 'name': voice.name, label: voice.name });
                    });
                    voiceOptions.push({ 'name': 'default', label: 'Browser Generated' });
                    that.setState({ voices: voiceOptions });
                    console.log(['VOICES a', voiceOptions]);
                };

                // Execute loadVoices.


                loadVoices();

                // Chrome loads voices asynchronously.
                window.speechSynthesis.onvoiceschanged = function (e) {
                    loadVoices();
                };
            } else {
                var voiceOptions = [];
                voiceOptions.push({ 'name': 'default', label: 'Browser Generated' });
                that.setState({ voices: voiceOptions });
                console.log(['VOICES b', voiceOptions]);
            }
            console.log(['LOADE VOICES', this.state.voices]);
        }
    }, {
        key: 'sendHotwordToggleOn',


        /**
         * Send Mqtt message to toggle on hotword
         * Used to forcibly initialise the local hotword server.
         */
        value: function sendHotwordToggleOn(siteId) {
            var that = this;
            if (this.state.connected) {
                var message = new Paho.MQTT.Message(JSON.stringify({ siteId: siteId }));
                message.destinationName = "hermes/hotword/toggleOn";
                that.mqttClient.send(message);
            }
        }
    }, {
        key: 'sendHotwordDetected',

        /**
         * Send Mqtt message to fake hotword detection
         */
        value: function sendHotwordDetected(hotwordId, siteId) {
            if (this.state.connected) {
                var message = new Paho.MQTT.Message(JSON.stringify({ siteId: siteId, modelId: hotwordId, modelType: 'universal' }));
                message.destinationName = "hermes/hotword/" + hotwordId + "/detected";
                this.mqttClient.send(message);
            }
        }
        /**
         * Send Mqtt message to indicate that tts has finished
         */

    }, {
        key: 'sendSayFinished',
        value: function sendSayFinished(id, sessionId) {
            if (this.state.connected) {
                var message = new Paho.MQTT.Message(JSON.stringify({ id: id, sessionId: sessionId }));
                message.destinationName = "hermes/tts/sayFinished";
                this.mqttClient.send(message);
            }
        }
    }, {
        key: 'sendPlayFinished',


        /**
         * Send Mqtt message to indicate audioserver playback has finished
         */
        value: function sendPlayFinished(siteId, sessionId) {
            if (this.state.connected) {
                var message = new Paho.MQTT.Message(JSON.stringify({ siteId: siteId, id: sessionId }));
                message.destinationName = "hermes/audioServer/" + this.siteId + "/playFinished";
                this.mqttClient.send(message);
            }
        }
    }, {
        key: 'sendEndSession',


        /**
         * Send Mqtt message to end the session immediately
         */
        value: function sendEndSession(sessionId) {
            if (this.state.connected) {
                var message = new Paho.MQTT.Message(JSON.stringify({ sessionId: sessionId }));
                message.destinationName = "hermes/dialogueManager/endSession";
                this.mqttClient.send(message);
            }
        }
    }, {
        key: 'sendTestSay',


        /**
         * Send Mqtt message to end the session immediately
         */
        value: function sendTestSay(e) {
            e.preventDefault();
            if (this.state.connected) {
                var message = new Paho.MQTT.Message(JSON.stringify({ siteId: this.siteId, text: 'This is a test to hear how I speak.' }));
                message.destinationName = "hermes/tts/say";
                this.mqttClient.send(message);
            }
        }
    }, {
        key: 'onMessageArrived',


        /**
         * Handle mqtt messages
         * By topic
         *   - asr
         *      - hermes/asr/<>/textCaptured
         *      - hermes/asr/startListening
         *      - hermes/asr/stopListening
         *   - audioserver
         *      - hermes/audioserver/playBytes
         *   - hotword
         *      - hermes/hotword/toggleOff
         *      - hermes/hotword/toggleOff
         *   - tts
         *      - hermes/tts/say
         *   - dialogueManager
         *     - hermes/dialogueManager/sessionStarted
         *     - hermes/dialogueManager/sessionEnded
         * TODO
         *   - intent - app server with debounce
         */
        value: function onMessageArrived(message) {
            var parts = message.destinationName ? message.destinationName.split("/") : [];
            var mainTopic = parts.slice(0, -1).join("/");
            var audio = message.payloadBytes;
            var payload = {};
            try {
                payload = JSON.parse(message.payloadString);
            } catch (e) {}
            if (this.debug) {
                console.log(['MESSAGE', message.destinationName, this.sessionId, mainTopic, audio.length, payload, message]);
            }
            if (parts[0] === "hermes" && parts[1] === "asr" && parts[2] === "textCaptured") {
                this.logAsr(this.sessionId, payload.text);
                this.flashState('lastTranscript', payload.text);
            } else if (parts[0] === "hermes" && parts[1] === "intent") {
                this.flashState('lastIntent', parts[2] + ":" + JSON.stringify(payload.slots));
                this.logIntent(this.sessionId, { intent: parts[2], slots: payload.slots });
            } else if (parts[0] === "hermes" && parts[1] === "tts" && parts[2] === "say") {
                if (payload.siteId && payload.siteId === this.siteId) {
                    this.logTts(this.sessionId, payload.text);
                    this.flashState('lastTts', payload.text);
                    this.speakAloud.bind(this)(payload.text);
                    this.sendSayFinished.bind(this)(payload.id, payload.sessionId);
                }
            } else if (parts[0] === "hermes" && parts[1] === "audioServer" && parts[2] === this.siteId && parts[3] === "playBytes") {
                this.playSound(audio);
                var newSessionId = parts.length > 0 ? parts[parts.length - 1] : '';
                if (parts.length > 3 && parts[4] && parts[4].length > 0) newSessionId = parts[4];
                this.sendPlayFinished.bind(this)(this.siteId, newSessionId);
            } else if (message.destinationName === "hermes/dialogueManager/sessionStarted") {
                this.sessionId = payload.sessionId;
            } else if (message.destinationName === "hermes/dialogueManager/sessionEnded") {
                this.recording = false;
                this.setState({ recording: false });
            } else if (message.destinationName === "hermes/asr/startListening") {
                this.audioBuffer = [];
                this.recordingLength = 0;
                this.recording = true;
                this.setState({ recording: true });
            } else if (message.destinationName === "hermes/asr/stopListening") {
                console.log(['STOP LISTENING']);
                this.logAudio(this.sessionId, this.audioBuffer);

                this.recording = false;
                this.setState({ recording: false });
            } else if (!this.props.disableHotword && message.destinationName === "hermes/hotword/toggleOn") {
                this.startHotword.bind(this)(payload.siteId);
            } else if (!this.props.disableHotword && message.destinationName == "hermes/hotword/toggleOff") {
                if (payload.siteId === this.siteId) {
                    this.stopHotword.bind(this)();
                }
            }
        }
    }, {
        key: 'stopHotword',


        /**
         * Pause the hotword manager
         */
        value: function stopHotword() {
            this.hotwordManager.pauseProcessing();
        }
    }, {
        key: 'startHotword',


        /**
         * Create or continue the hotword manager
         */
        value: function startHotword(siteId) {
            console.log(['start hotword', siteId, this.siteId]);
            if (siteId === this.siteId) {
                if (this.hotwordManager === null) {
                    this.hotwordManager = new PicovoiceAudioManager();
                    var singleSensitivity = this.state.config.hotwordsensitivity ? this.state.config.hotwordsensitivity / 100 : 0.5;
                    var sensitivities = new Float32Array([singleSensitivity]);
                    this.hotwordManager.start(Porcupine.create(Object.values(this.keywordIDs), sensitivities), this.hotwordCallback, function (e) {
                        console.log(['hotword error', e]);
                    });
                } else {
                    this.hotwordManager.continueProcessing();
                }
            }
        }

        /**
         * Enable streaming of the audio input stream
         */

    }, {
        key: 'playSound',
        value: function playSound(bytes) {
            if (this.state.config.enableaudio !== "no") {
                var buffer = new Uint8Array(bytes.length);
                buffer.set(new Uint8Array(bytes), 0);
                var audioContext = window.AudioContext || window.webkitAudioContext;
                var context = new audioContext();

                context.decodeAudioData(buffer.buffer, function (audioBuffer) {
                    var source = context.createBufferSource();
                    source.buffer = audioBuffer;
                    source.connect(context.destination);
                    source.start(0);
                });
            }
        }
    }, {
        key: 'flashState',
        value: function flashState(key, value) {
            var that = this;
            if (key && key.length > 0 && value && value.length > 0) {
                if (this.messageTimeOut) clearTimeout(this.messageTimeOut);
                var newObj = { showMessage: true };
                if (key === "lastTranscript") {
                    newObj.lastIntent = '';
                    newObj.lastTts = '';
                }
                newObj[key] = value;
                this.setState(newObj);
                setTimeout(function () {
                    that.setState({ showMessage: false });
                }, that.props.messageTimeout > 0 ? that.props.messageTimeout : 10000);
            }
        }
    }, {
        key: 'hotwordCallback',
        value: function hotwordCallback(e) {
            if (e == 0) {
                this.startRecording();
            }
        }
    }, {
        key: 'sendAudioBuffer',


        /** WAV encoding functions */

        value: function sendAudioBuffer(buffer, sampleRate) {
            var that = this;
            //this.audioBuffer
            if (buffer) {
                this.reSample(buffer, 16000, function (result) {
                    var wav = that.audioBufferToWav(result); //new WaveFile().fromScratch(1,16000,"16",result);
                    var message = new Paho.MQTT.Message(wav);
                    message.destinationName = "hermes/audioServer/" + that.siteId + "/audioFrame";
                    that.mqttClient.send(message);
                }, sampleRate);
            }
        }
    }, {
        key: 'convertFloat32ToInt16',


        /** 
         * WAV encoding functions 
         */

        value: function convertFloat32ToInt16(buffer) {
            var l = buffer.length;
            var buf = new Int16Array(l);
            while (l--) {
                buf[l] = Math.min(1, buffer[l]) * 0x7FFF;
            }
            return buf.buffer;
        }
    }, {
        key: 'flattenArray',
        value: function flattenArray(inChannelBuffer, recordingLength) {
            var channelBuffer = this.convertFloat32ToInt16(inChannelBuffer);

            var result = new Float32Array(recordingLength);
            var offset = 0;
            for (var i = 0; i < channelBuffer.length; i++) {
                var buffer = channelBuffer[i];
                result.set(buffer, offset);
                offset += buffer.length;
            }
            return result;
        }
    }, {
        key: 'reSample',
        value: function reSample(audioBuffer, targetSampleRate, onComplete, sampleRateContext) {
            var sampleRate = !isNaN(sampleRateContext) ? sampleRateContext : 44100;
            var channel = audioBuffer && audioBuffer.numberOfChannels ? audioBuffer.numberOfChannels : 1;
            var samples = audioBuffer.length * targetSampleRate / sampleRate;
            var offlineContext = new OfflineAudioContext(channel, samples, targetSampleRate);
            var bufferSource = offlineContext.createBufferSource();
            bufferSource.buffer = audioBuffer;

            bufferSource.connect(offlineContext.destination);
            bufferSource.start(0);
            offlineContext.startRendering().then(function (renderedBuffer) {
                onComplete(renderedBuffer);
            }).catch(function (e) {
                console.log(e);
            });
        }
    }, {
        key: 'audioBufferToWav',
        value: function audioBufferToWav(buffer, opt) {
            opt = opt || {};

            var numChannels = buffer.numberOfChannels;
            var sampleRate = buffer.sampleRate;
            var format = opt.float32 ? 3 : 1;
            var bitDepth = format === 3 ? 32 : 16;

            var result;
            if (numChannels === 2) {
                result = this.interleave(buffer.getChannelData(0), buffer.getChannelData(1));
            } else {
                result = buffer.getChannelData(0);
            }

            return this.encodeWAV(result, format, sampleRate, numChannels, bitDepth);
        }
    }, {
        key: 'encodeWAV',
        value: function encodeWAV(samples, format, sampleRate, numChannels, bitDepth) {
            var bytesPerSample = bitDepth / 8;
            var blockAlign = numChannels * bytesPerSample;

            var buffer = new ArrayBuffer(44 + samples.length * bytesPerSample);
            var view = new DataView(buffer);

            /* RIFF identifier */
            this.writeString(view, 0, 'RIFF');
            /* RIFF chunk length */
            view.setUint32(4, 36 + samples.length * bytesPerSample, true);
            /* RIFF type */
            this.writeString(view, 8, 'WAVE');
            /* format chunk identifier */
            this.writeString(view, 12, 'fmt ');
            /* format chunk length */
            view.setUint32(16, 16, true);
            /* sample format (raw) */
            view.setUint16(20, format, true);
            /* channel count */
            view.setUint16(22, numChannels, true);
            /* sample rate */
            view.setUint32(24, sampleRate, true);
            /* byte rate (sample rate * block align) */
            view.setUint32(28, sampleRate * blockAlign, true);
            /* block align (channel count * bytes per sample) */
            view.setUint16(32, blockAlign, true);
            /* bits per sample */
            view.setUint16(34, bitDepth, true);
            /* data chunk identifier */
            this.writeString(view, 36, 'data');
            /* data chunk length */
            view.setUint32(40, samples.length * bytesPerSample, true);
            if (format === 1) {
                // Raw PCM
                this.floatTo16BitPCM(view, 44, samples);
            } else {
                this.writeFloat32(view, 44, samples);
            }

            return buffer;
        }
    }, {
        key: 'interleave',
        value: function interleave(inputL, inputR) {
            var length = inputL.length + inputR.length;
            var result = new Float32Array(length);

            var index = 0;
            var inputIndex = 0;

            while (index < length) {
                result[index++] = inputL[inputIndex];
                result[index++] = inputR[inputIndex];
                inputIndex++;
            }
            return result;
        }
    }, {
        key: 'writeFloat32',
        value: function writeFloat32(output, offset, input) {
            for (var i = 0; i < input.length; i++, offset += 4) {
                output.setFloat32(offset, input[i], true);
            }
        }
    }, {
        key: 'floatTo16BitPCM',
        value: function floatTo16BitPCM(output, offset, input) {
            for (var i = 0; i < input.length; i++, offset += 2) {
                var s = Math.max(-1, Math.min(1, input[i]));
                output.setInt16(offset, s < 0 ? s * 0x8000 : s * 0x7FFF, true);
            }
        }
    }, {
        key: 'writeString',
        value: function writeString(view, offset, string) {
            for (var i = 0; i < string.length; i++) {
                view.setUint8(offset + i, string.charCodeAt(i));
            }
        }

        /**
         * CSS SPEECH BUBBLE LAYOUT
         * from https://github.com/LeaVerou/bubbly/blob/gh-pages/bubbly.js
        */

    }, {
        key: 'bubbleCSS',
        value: function bubbleCSS(settings) {
            var selector = '.microphone-speechbubble';
            var props = {},
                propsBefore = {};
            props['position'] = 'relative';
            props['background'] = settings.color;
            props['border-radius'] = '.4em';

            var side = settings.side,
                triangle = settings.triangle,
                isHorizontal = side == 'top' || side == 'bottom',
                opposite = {
                'top': 'bottom',
                'right': 'left',
                'bottom': 'top',
                'left': 'right'
            }[side],
                offset = isHorizontal ? 'left' : 'top';

            propsBefore['content'] = "''";
            propsBefore['position'] = 'absolute';
            propsBefore[side] = '0';
            propsBefore[offset] = '50%';

            propsBefore['width'] = '0';
            propsBefore['height'] = '0';

            propsBefore['border'] = this.getPointerLength(settings.size, settings.ems) + ' solid transparent';
            propsBefore['border-' + opposite + '-color'] = settings.color;
            propsBefore['border-' + side] = '0';

            if (triangle != 'symmetrical') {
                propsBefore['border-' + (isHorizontal ? triangle : triangle == 'right' ? 'top' : 'bottom')] = '0';
            }

            propsBefore['margin-' + offset] = this.getPointerLength(-settings.size / (triangle == 'symmetrical' ? 1 : 2)); // to center it
            propsBefore['margin-' + side] = this.getPointerLength(-settings.size, settings.ems); // to put it outside the box

            return this.cssRule(selector, props) + '\n\n' + this.cssRule(selector + ':after', propsBefore);
        }
    }, {
        key: 'getPointerLength',
        value: function getPointerLength(px) {
            return px + 'px';
        }
    }, {
        key: 'cssRule',
        value: function cssRule(selector, props) {
            var css = selector + ' {\n';

            for (var property in props) {
                var value = props[property];
                css += '	' + property + ': ' + value + ';\n';
            }

            css += '}';

            return css;
        }

        /** 
         * Functions to enable and disable configuration screen 
         * by default using a debounce to implement click and hold to enable config
         **/

    }, {
        key: 'showConfig',
        value: function showConfig(e) {
            var that = this;
            this.configTimeout = setTimeout(function () {
                console.log('show now');
                that.setState({ showConfig: true });
            }, 1000);
        }
    }, {
        key: 'showConfigNow',
        value: function showConfigNow(e) {
            e.preventDefault();
            e.stopPropagation();
            this.setState({ showConfig: true });
        }
    }, {
        key: 'clearConfigTimer',
        value: function clearConfigTimer() {
            if (this.configTimeout) clearTimeout(this.configTimeout);
        }
    }, {
        key: 'hideConfig',
        value: function hideConfig() {
            this.setState({ showConfig: false });
        }
    }, {
        key: 'configurationChange',
        value: function configurationChange(e) {
            console.log(['configurationChange', this, e, e.target.value, e.target.id]);
            var config = this.state.config;
            config[e.target.id] = e.target.value;
            this.setState(config);
            // set silence threshhold directly
            if (e.target.id === "silencesensitivity" && this.speechEvents) {
                this.speechEvents.setThreshold(10 * Math.log(this.state.config.silencesensitivity / 100));
            }
            localStorage.setItem('snipsmicrophone_config', JSON.stringify(config));
        }
    }, {
        key: 'newLog',
        value: function newLog(sessionId) {
            return { timestamp: new Date().getTime(), siteId: this.siteId, sessionId: sessionId, hotwordId: this.hotwordId, asr: [], intents: [], audio: [], tts: [] };
        }
    }, {
        key: 'startLogEntry',
        value: function startLogEntry(sessionId) {
            var logs = this.state.logs;
            var newLog = this.newLog.bind(this)(sessionId);
            logs[sessionId] = newLog;
            this.setState({ logs: logs });
            console.log(['start LOG', newLog]);
            return newLog;
        }
    }, {
        key: 'currentLogEntry',
        value: function currentLogEntry(sessionId, logs) {
            if (sessionId && sessionId.length) {
                if (logs && logs.hasOwnProperty(sessionId)) {
                    console.log(['CURRENT LOG', sessionId, logs[sessionId]]);
                    return logs[sessionId];
                    // create first log entry
                } else {
                    console.log(['new LOG', sessionId]);
                    return this.startLogEntry(sessionId);
                }
            } else {
                console.log(['INVALID sessionId for log:', sessionId]);
            }
            return logs[0];
        }
    }, {
        key: 'logAsr',
        value: function logAsr(sessionId, text) {
            var logs = this.state.logs;
            var currentLog = this.currentLogEntry.bind(this)(sessionId, logs);
            currentLog.asr.push(text);
            console.log(['start LOG asr', text, sessionId]);
            this.setState({ logs: logs });
        }
    }, {
        key: 'logIntent',
        value: function logIntent(sessionId, intent) {
            var logs = this.state.logs;
            var currentLog = this.currentLogEntry.bind(this)(sessionId, logs);
            currentLog.intents.push(intent);
            console.log(['start LOG intent', intent, sessionId]);
            this.setState({ logs: logs });
        }
    }, {
        key: 'logTts',
        value: function logTts(sessionId, text) {
            if (sessionId && sessionId.length) {
                var logs = this.state.logs;
                var currentLog = this.currentLogEntry.bind(this)(sessionId, logs);
                currentLog.tts.push(text);
                console.log(['start LOG tts', text, sessionId]);
                this.setState({ logs: logs });
            }
        }
    }, {
        key: 'logAudio',
        value: function logAudio(sessionId, audio) {
            console.log(['start LOG audio', sessionId]);
            var logs = this.state.logs;
            var finalBuffer = this.flattenArray(audio, this.recordingLength);
            // audio to audioBuffer

            //this.reSample(audio,16000,function(result) {
            //console.log(['resampled LOG audio',result]);
            //let wav = that.audioBufferToWav(result) ; //new WaveFile().fromScratch(1,16000,"16",result);
            //let currentLog = that.currentLogEntry.bind(that)(sessionId,logs);
            //currentLog.audio.push(intent);
            //that.setState({logs:logs});

            //});
        }
    }, {
        key: 'render',
        value: function render() {
            var that = this;
            var text = this.props.text;


            var buttonStyle = this.props.buttonStyle ? this.props.buttonStyle : {};

            var size = this.props.size && this.props.size.length > 0 ? this.props.size : '2em';
            //if (size) {
            buttonStyle.width = size;
            buttonStyle.height = size;
            //}
            // set speech bubble css THEN
            //Object.assign(speechBubbleStyle,this.getBubbleStyle(this.props.speechBubbleAt && this.props.speechBubbleAt.length > 0 ? this.props.speechBubbleAt : 'bottomleft' ))     ;

            var position = this.props.position && this.props.position.length > 0 ? this.props.position : 'topright';
            // set mic position and override bubble position
            buttonStyle.position = 'fixed';
            if (position === "topleft") {
                buttonStyle.top = 0;
                buttonStyle.left = 0;
            } else if (position === "topright") {
                buttonStyle.top = 0;
                buttonStyle.right = 0;
            } else if (position === "bottomleft") {
                buttonStyle.bottom = 0;
                buttonStyle.left = 0;
            } else if (position === "bottomright") {
                buttonStyle.bottom = 0;
                buttonStyle.right = 0;
            }

            var status = 0;
            if (this.state.activated) status = 1;
            if (this.state.connected) status = 2;
            if (this.state.recording) status = 3;
            //if (this.state.sending) status = 3;
            // console.log(status);
            var borderColor = 'black';
            var borderWidth = 2;
            if (status == 3) {
                borderColor = this.state.speaking ? 'darkgreen' : this.props.borderColor ? this.props.borderColor : 'green';
                buttonStyle.backgroundColor = 'lightgreen';
                if (this.state.speaking) borderWidth = 3;
            } else if (status == 1) {
                borderColor = this.state.speaking ? 'darkorange' : this.props.borderColor ? this.props.borderColor : 'orange';
                buttonStyle.backgroundColor = 'lightorange';
                if (this.state.speaking) borderWidth = 3;
            } else if (status == 2) {
                borderColor = this.state.speaking ? 'orangered' : this.props.borderColor ? this.props.borderColor : 'red';
                buttonStyle.backgroundColor = 'pink';
                if (this.state.speaking) borderWidth = 3;
            } else {
                borderColor = this.props.borderColor ? this.props.borderColor : 'black';
                buttonStyle.backgroundColor = 'lightgrey';
            }
            if (!buttonStyle.padding) buttonStyle.padding = '0.5em';
            if (!buttonStyle.margin) buttonStyle.margin = '0.5em';
            // console.log(borderColor);
            //if (!buttonStyle.border) 
            buttonStyle.border = borderWidth + 'px solid ' + borderColor;
            if (!buttonStyle.borderRadius) buttonStyle.borderRadius = '100px';

            var micOffIcon = React__default.createElement(
                'svg',
                { style: buttonStyle, 'aria-hidden': 'true', 'data-prefix': 'fas', 'data-icon': 'microphone', className: 'svg-inline--fa fa-microphone fa-w-11', role: 'img', xmlns: 'http://www.w3.org/2000/svg', viewBox: '0 0 352 512' },
                React__default.createElement('path', { fill: 'currentColor', d: 'M176 352c53.02 0 96-42.98 96-96V96c0-53.02-42.98-96-96-96S80 42.98 80 96v160c0 53.02 42.98 96 96 96zm160-160h-16c-8.84 0-16 7.16-16 16v48c0 74.8-64.49 134.82-140.79 127.38C96.71 376.89 48 317.11 48 250.3V208c0-8.84-7.16-16-16-16H16c-8.84 0-16 7.16-16 16v40.16c0 89.64 63.97 169.55 152 181.69V464H96c-8.84 0-16 7.16-16 16v16c0 8.84 7.16 16 16 16h160c8.84 0 16-7.16 16-16v-16c0-8.84-7.16-16-16-16h-56v-33.77C285.71 418.47 352 344.9 352 256v-48c0-8.84-7.16-16-16-16z' })
            );

            var micOnIcon = React__default.createElement(
                'svg',
                { style: buttonStyle, 'aria-hidden': 'true', 'data-prefix': 'fas', 'data-icon': 'microphone-slash', className: 'svg-inline--fa fa-microphone-slash fa-w-20', role: 'img', xmlns: 'http://www.w3.org/2000/svg', viewBox: '0 0 640 512' },
                React__default.createElement('path', { fill: 'currentColor', d: 'M633.82 458.1l-157.8-121.96C488.61 312.13 496 285.01 496 256v-48c0-8.84-7.16-16-16-16h-16c-8.84 0-16 7.16-16 16v48c0 17.92-3.96 34.8-10.72 50.2l-26.55-20.52c3.1-9.4 5.28-19.22 5.28-29.67V96c0-53.02-42.98-96-96-96s-96 42.98-96 96v45.36L45.47 3.37C38.49-2.05 28.43-.8 23.01 6.18L3.37 31.45C-2.05 38.42-.8 48.47 6.18 53.9l588.36 454.73c6.98 5.43 17.03 4.17 22.46-2.81l19.64-25.27c5.41-6.97 4.16-17.02-2.82-22.45zM400 464h-56v-33.77c11.66-1.6 22.85-4.54 33.67-8.31l-50.11-38.73c-6.71.4-13.41.87-20.35.2-55.85-5.45-98.74-48.63-111.18-101.85L144 241.31v6.85c0 89.64 63.97 169.55 152 181.69V464h-56c-8.84 0-16 7.16-16 16v16c0 8.84 7.16 16 16 16h160c8.84 0 16-7.16 16-16v-16c0-8.84-7.16-16-16-16z' })
            );

            var resetIcon = React__default.createElement(
                'svg',
                { 'aria-hidden': 'true', style: { height: '1.1em' }, role: 'img', xmlns: 'http://www.w3.org/2000/svg', viewBox: '0 0 512 512' },
                React__default.createElement('path', { fill: 'currentColor', d: 'M500.333 0h-47.411c-6.853 0-12.314 5.729-11.986 12.574l3.966 82.759C399.416 41.899 331.672 8 256.001 8 119.34 8 7.899 119.526 8 256.187 8.101 393.068 119.096 504 256 504c63.926 0 122.202-24.187 166.178-63.908 5.113-4.618 5.354-12.561.482-17.433l-33.971-33.971c-4.466-4.466-11.64-4.717-16.38-.543C341.308 415.448 300.606 432 256 432c-97.267 0-176-78.716-176-176 0-97.267 78.716-176 176-176 60.892 0 114.506 30.858 146.099 77.8l-101.525-4.865c-6.845-.328-12.574 5.133-12.574 11.986v47.411c0 6.627 5.373 12 12 12h200.333c6.627 0 12-5.373 12-12V12c0-6.627-5.373-12-12-12z' })
            );

            var stopIcon2 = React__default.createElement(
                'svg',
                { 'aria-hidden': 'true', style: { height: '1.4em' }, role: 'img', xmlns: 'http://www.w3.org/2000/svg', viewBox: '0 0 512 512' },
                React__default.createElement('path', { fill: 'currentColor', d: 'M440.5 88.5l-52 52L415 167c9.4 9.4 9.4 24.6 0 33.9l-17.4 17.4c11.8 26.1 18.4 55.1 18.4 85.6 0 114.9-93.1 208-208 208S0 418.9 0 304 93.1 96 208 96c30.5 0 59.5 6.6 85.6 18.4L311 97c9.4-9.4 24.6-9.4 33.9 0l26.5 26.5 52-52 17.1 17zM500 60h-24c-6.6 0-12 5.4-12 12s5.4 12 12 12h24c6.6 0 12-5.4 12-12s-5.4-12-12-12zM440 0c-6.6 0-12 5.4-12 12v24c0 6.6 5.4 12 12 12s12-5.4 12-12V12c0-6.6-5.4-12-12-12zm33.9 55l17-17c4.7-4.7 4.7-12.3 0-17-4.7-4.7-12.3-4.7-17 0l-17 17c-4.7 4.7-4.7 12.3 0 17 4.8 4.7 12.4 4.7 17 0zm-67.8 0c4.7 4.7 12.3 4.7 17 0 4.7-4.7 4.7-12.3 0-17l-17-17c-4.7-4.7-12.3-4.7-17 0-4.7 4.7-4.7 12.3 0 17l17 17zm67.8 34c-4.7-4.7-12.3-4.7-17 0-4.7 4.7-4.7 12.3 0 17l17 17c4.7 4.7 12.3 4.7 17 0 4.7-4.7 4.7-12.3 0-17l-17-17zM112 272c0-35.3 28.7-64 64-64 8.8 0 16-7.2 16-16s-7.2-16-16-16c-52.9 0-96 43.1-96 96 0 8.8 7.2 16 16 16s16-7.2 16-16z' })
            );

            var logItems = Object.keys(this.state.logs).map(function (sessionId, key) {
                var sessionLog = that.state.logs[sessionId];
                var speechItems = sessionLog.asr.map(function (transcript, ikey) {
                    var slotValues = [];
                    if (sessionLog.intents[ikey]) slotValues = sessionLog.intents[ikey].slots.map(function (slot, skey) {
                        return React__default.createElement(
                            'li',
                            null,
                            slot.slotName.split('_').join(' '),
                            ' ',
                            slot.value.value
                        );
                    });
                    return React__default.createElement(
                        'div',
                        null,
                        React__default.createElement(
                            'div',
                            { style: { marginBottom: '1em', fontWeight: 'bold' } },
                            transcript
                        ),
                        React__default.createElement(
                            'div',
                            null,
                            React__default.createElement(
                                'span',
                                null,
                                sessionLog.intents[ikey] && sessionLog.intents[ikey].intent
                            ),
                            slotValues && React__default.createElement(
                                'ul',
                                null,
                                slotValues
                            )
                        ),
                        React__default.createElement(
                            'div',
                            null,
                            React__default.createElement(
                                'i',
                                null,
                                sessionLog.tts[ikey]
                            )
                        ),
                        React__default.createElement(
                            'span',
                            null,
                            sessionLog.audio[ikey] && sessionLog.audio[ikey].length
                        ),
                        React__default.createElement(
                            'div',
                            null,
                            React__default.createElement('hr', { style: { height: '1px', width: '100%' } })
                        )
                    );
                });

                return React__default.createElement(
                    'div',
                    null,
                    React__default.createElement(
                        'div',
                        null,
                        React__default.createElement('hr', { style: { height: '5px', width: '100%' } })
                    ),
                    React__default.createElement(
                        'div',
                        null,
                        speechItems
                    )
                );
            });

            var voiceOptions = this.state.voices && this.state.voices.map(function (voice) {
                return React__default.createElement(
                    'option',
                    { value: voice.name },
                    voice.label
                );
            });

            var ro = this.props.remoteOptions ? this.props.remoteOptions : [];
            var remoteOptions = ro.map(function (remoteSite) {
                return React__default.createElement(
                    'option',
                    { value: remoteSite.name },
                    remoteSite.label
                );
            });
            remoteOptions.unshift(React__default.createElement(
                'option',
                { value: 'local' },
                'Local'
            ));

            var inputStyle = { marginBottom: '0.5em', fontSize: '0.9em' };
            var config = this.state.config;
            return React__default.createElement(
                'div',
                null,
                this.state.showConfig && React__default.createElement(
                    'div',
                    { style: { minHeight: '25em', margin: '2em', padding: '1em', width: '90%', border: '2px solid black', borderRadius: '10px', backgroundColor: 'white' } },
                    React__default.createElement(
                        'button',
                        { style: { float: 'right', fontSize: '1.6em', fontWeight: 'bold', border: '2px solid black', borderRadius: '50px' }, onClick: this.hideConfig },
                        'X'
                    ),
                    React__default.createElement(
                        'div',
                        { style: { float: 'left', marginRight: '2em' } },
                        status >= 2 && React__default.createElement(
                            'span',
                            { onClick: this.deactivate },
                            React__default.createElement(
                                'button',
                                { className: 'btn btn-danger', style: { fontSize: '1.5em' } },
                                ' ',
                                stopIcon2,
                                ' Disable '
                            )
                        )
                    ),
                    React__default.createElement(
                        'h1',
                        null,
                        'Microphone Configuration'
                    ),
                    React__default.createElement(
                        'form',
                        { style: { fontSize: '1.8em' } },
                        React__default.createElement(
                            'div',
                            { style: { float: 'right' } },
                            React__default.createElement(AudioMeter, { style: { float: 'right', marginRight: "2em", height: '200', width: '50', dtooLoudColor: "#FF9800", scolor: '#889bd8', border: '1px solid black', backgroundColor: 'lightgrey' } })
                        ),
                        React__default.createElement(
                            'div',
                            { style: { float: 'left', width: '80%' } },
                            React__default.createElement(
                                'div',
                                { className: 'form-group' },
                                React__default.createElement(
                                    'b',
                                    { style: { marginBottom: '0.8em' } },
                                    'Volume\xA0\xA0\xA0'
                                )
                            ),
                            React__default.createElement(
                                'div',
                                { className: 'form-group' },
                                React__default.createElement(
                                    'label',
                                    { htmlFor: 'inputvolume' },
                                    'Microphone '
                                ),
                                React__default.createElement('input', { type: 'range', id: 'inputvolume', value: config.inputvolume, onChange: this.configurationChange.bind(this), style: Object.assign({ width: '80%' }, inputStyle) })
                            ),
                            React__default.createElement(
                                'div',
                                { className: 'form-group' },
                                React__default.createElement(
                                    'label',
                                    { htmlFor: 'outputvolume' },
                                    'Output '
                                ),
                                React__default.createElement('input', { type: 'range', id: 'outputvolume', value: config.outputvolume, onChange: this.configurationChange.bind(this), style: Object.assign({ width: '80%' }, inputStyle) })
                            ),
                            React__default.createElement(
                                'div',
                                { className: 'form-group' },
                                React__default.createElement(
                                    'label',
                                    { htmlFor: 'voicevolume' },
                                    'Voice '
                                ),
                                React__default.createElement('input', { type: 'range', id: 'voicevolume', value: config.voicevolume, onChange: this.configurationChange.bind(this), style: Object.assign({ width: '80%' }, inputStyle) })
                            )
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-group' },
                            React__default.createElement('hr', { style: { width: '100%' } })
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-group' },
                            React__default.createElement(
                                'label',
                                { htmlFor: 'remotecontrol' },
                                'Remote Control '
                            ),
                            React__default.createElement(
                                'select',
                                { style: inputStyle, id: 'remotecontrol', value: config.remotecontrol, onChange: this.configurationChange.bind(this) },
                                remoteOptions
                            )
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-group' },
                            React__default.createElement('hr', { style: { width: '100%' } })
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-inline' },
                            React__default.createElement(
                                'label',
                                { htmlFor: 'ttsvoice' },
                                'Voice '
                            ),
                            React__default.createElement(
                                'select',
                                { style: inputStyle, id: 'ttsvoice', value: config.ttsvoice, onChange: this.configurationChange.bind(this) },
                                voiceOptions
                            ),
                            '\xA0\xA0\xA0',
                            React__default.createElement(
                                'button',
                                { className: 'btn btn-success', style: { fontSize: '1em' }, onClick: this.sendTestSay.bind(this) },
                                'Test'
                            )
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-group' },
                            React__default.createElement(
                                'label',
                                { htmlFor: 'voicerate' },
                                'Rate '
                            ),
                            React__default.createElement('input', { type: 'range', id: 'voicerate', value: config.voicerate, onChange: this.configurationChange.bind(this), style: Object.assign({ width: '80%' }, inputStyle) })
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-group' },
                            React__default.createElement(
                                'label',
                                { htmlFor: 'voicepitch' },
                                'Pitch '
                            ),
                            React__default.createElement('input', { type: 'range', id: 'voicepitch', value: config.voicepitch, onChange: this.configurationChange.bind(this), style: Object.assign({ width: '80%' }, inputStyle) })
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-group' },
                            React__default.createElement('hr', { style: { width: '100%' } })
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-group' },
                            React__default.createElement(
                                'label',
                                { htmlFor: 'hotword' },
                                'Hotword '
                            ),
                            React__default.createElement(
                                'select',
                                { style: inputStyle, id: 'hotword', value: config.hotword, onChange: this.configurationChange.bind(this) },
                                React__default.createElement(
                                    'option',
                                    { value: 'browser:oklamp' },
                                    'OK Lamp (Browser)'
                                ),
                                React__default.createElement(
                                    'option',
                                    { value: 'server:heysnips' },
                                    'Hey Snips (Server)'
                                ),
                                React__default.createElement(
                                    'option',
                                    { value: 'disabled' },
                                    'Disabled'
                                )
                            )
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-group' },
                            React__default.createElement(
                                'label',
                                { htmlFor: 'hotwordsensitivity' },
                                'Hotword Sensitivity '
                            ),
                            React__default.createElement('input', { type: 'range', id: 'hotwordsensitivity', value: config.hotwordsensitivity, onChange: this.configurationChange.bind(this), style: Object.assign({ width: '80%' }, inputStyle) })
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-group' },
                            React__default.createElement('hr', { style: { width: '100%' } })
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-group' },
                            this.state.speaking && React__default.createElement(
                                'span',
                                { style: { float: 'right' } },
                                'Speaking'
                            ),
                            React__default.createElement(
                                'label',
                                { htmlFor: 'silencedetection' },
                                'Silence Detection '
                            ),
                            React__default.createElement(
                                'select',
                                { style: inputStyle, id: 'silencedetection', value: config.silencedetection, onChange: this.configurationChange.bind(this) },
                                React__default.createElement(
                                    'option',
                                    { value: 'yes' },
                                    'Enabled'
                                ),
                                React__default.createElement(
                                    'option',
                                    { value: 'no' },
                                    'Disabled'
                                )
                            )
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-group' },
                            React__default.createElement(
                                'label',
                                { htmlFor: 'silencesensitivity' },
                                'Silence Sensitivity '
                            ),
                            React__default.createElement('input', { type: 'range', id: 'silencesensitivity', value: config.silencesensitivity, onChange: this.configurationChange.bind(this), style: Object.assign({ width: '80%' }, inputStyle) })
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-group' },
                            React__default.createElement('hr', { style: { width: '100%' } })
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-group' },
                            React__default.createElement(
                                'b',
                                { style: { marginBottom: '0.8em' } },
                                'Notifications\xA0\xA0\xA0'
                            )
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-inline' },
                            React__default.createElement(
                                'label',
                                { htmlFor: 'enabletts' },
                                ' Voice '
                            ),
                            React__default.createElement(
                                'select',
                                { style: inputStyle, id: 'enabletts', value: config.enabletts, onChange: this.configurationChange.bind(this) },
                                React__default.createElement(
                                    'option',
                                    { value: 'yes' },
                                    'Yes'
                                ),
                                React__default.createElement(
                                    'option',
                                    { value: 'no' },
                                    'No'
                                )
                            ),
                            React__default.createElement(
                                'label',
                                { htmlFor: 'enableaudio' },
                                ' Audio '
                            ),
                            React__default.createElement(
                                'select',
                                { style: inputStyle, id: 'enableaudio', value: config.enableaudio, onChange: this.configurationChange.bind(this) },
                                React__default.createElement(
                                    'option',
                                    { value: 'yes' },
                                    'Yes'
                                ),
                                React__default.createElement(
                                    'option',
                                    { value: 'no' },
                                    'No'
                                )
                            ),
                            React__default.createElement(
                                'label',
                                { htmlFor: 'enablenotifications' },
                                ' Screen '
                            ),
                            React__default.createElement(
                                'select',
                                { style: inputStyle, id: 'enablenotifications', value: config.enablenotifications, onChange: this.configurationChange.bind(this) },
                                React__default.createElement(
                                    'option',
                                    { value: 'yes' },
                                    'Yes'
                                ),
                                React__default.createElement(
                                    'option',
                                    { value: 'no' },
                                    'No'
                                )
                            )
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-group' },
                            React__default.createElement('hr', { style: { width: '100%' } }),
                            React__default.createElement(
                                'span',
                                { onClick: this.resetConfig },
                                React__default.createElement(
                                    'button',
                                    { className: 'btn btn-danger', style: { fontSize: '1em' } },
                                    ' ',
                                    resetIcon,
                                    ' Reset Configuration'
                                )
                            ),
                            React__default.createElement('hr', { style: { width: '100%' } })
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-group' },
                            React__default.createElement(
                                'b',
                                null,
                                'Logs\xA0\xA0\xA0'
                            ),
                            logItems
                        ),
                        React__default.createElement(
                            'div',
                            { className: 'form-group' },
                            React__default.createElement('br', null),
                            React__default.createElement('br', null),
                            React__default.createElement('br', null)
                        )
                    )
                ),
                !this.state.showConfig && this.state.config.enablenotifications !== "no" && React__default.createElement(
                    'div',
                    null,
                    !this.state.activated && React__default.createElement(
                        'span',
                        { onClick: this.activate },
                        micOnIcon
                    ),
                    this.state.activated && this.state.recording && React__default.createElement(
                        'span',
                        { onTouchStart: this.showConfig, onTouchEnd: this.clearConfigTimer, onMouseDown: this.showConfig, onMouseUp: this.clearConfigTimer, onContextMenu: this.showConfigNow, onClick: this.stopRecording },
                        micOffIcon
                    ),
                    this.state.activated && !this.state.recording && React__default.createElement(
                        'span',
                        { onTouchStart: this.showConfig, onTouchEnd: this.clearConfigTimer, onMouseDown: this.showConfig, onMouseUp: this.clearConfigTimer, onContextMenu: this.showConfigNow, onClick: this.startRecording },
                        micOnIcon
                    ),
                    this.state.showMessage && React__default.createElement(
                        'div',
                        { style: { padding: '1em', borderRadius: '20px', backgroundColor: 'skyblue', margin: '5%', width: '90%', top: '1.7em', color: 'black', border: '2px solid blue' } },
                        this.state.lastTranscript && React__default.createElement(
                            'div',
                            { style: { fontStyle: 'italic' } },
                            this.state.lastTranscript
                        ),
                        this.state.lastIntent && React__default.createElement(
                            'div',
                            null,
                            this.state.lastIntent
                        ),
                        this.state.lastTts && React__default.createElement(
                            'div',
                            null,
                            this.state.lastTts
                        )
                    )
                ),
                React__default.createElement('div', { id: 'audio' })
            );
        }
    }]);
    return SnipsMicrophone;
}(React.Component);

module.exports = SnipsMicrophone;
//# sourceMappingURL=index.js.map
